--
-- moresilotype
-- 
-- 
--
-- derelky project start: 26.10.2016
-- Version 1.0 - start with CCM
-- Version 1.1 - Rewrite Script to minimize the code and for better compatibilty to FS17 Patches




moresilotype = {};
addModEventListener(moresilotype);

function moresilotype:loadMap(name)
	print("--- loading CCM mod V1.1 --- (by derelky)")
end;

function moresilotype:deleteMap()
end


function moresilotype:mouseEvent(posX, posY, isDown, isUp, button)
end;

function moresilotype:keyEvent(unicode, sym, modifier, isDown)
end;

function moresilotype:update(dt)
end;


function moresilotype:draw()   
end;


local moresilotypeUpdate = BunkerSilo.update;
function BunkerSilo:update(dt)
	moresilotypeUpdate(self,dt);
    if self:getCanInteract(true) then
		if self.state ~= BunkerSilo.STATE_FILL or self.fillLevel > 1000 then
		else
				if self.isClient then
					g_currentMission:addHelpButtonText(g_i18n:getText("input_BGASILO_TYPE"), InputBinding.BGASILO_TYPE);
					if InputBinding.hasEvent(InputBinding.BGASILO_TYPE) then
						
						if	self.inputFillType==FillUtil.FILLTYPE_CHAFF then
							self.inputFillTypenew=FillUtil.FILLTYPE_CCMRAW;
							self.inputFillTypeold=FillUtil.FILLTYPE_CHAFF;
							self.outputFillType=FillUtil.FILLTYPE_CCM;
						else
							self.inputFillTypenew=FillUtil.FILLTYPE_CHAFF;
							self.inputFillTypeold=FillUtil.FILLTYPE_CCMRAW;
							self.outputFillType=FillUtil.FILLTYPE_SILAGE;
						end;

						self.inputFillType=self.inputFillTypenew;
						--if g_server ~= nil then
						--	g_server:broadcastEvent(ChangesilotypeEvent:new(self,self.inputFillType,self.inputFillTypeold,self.outputFillType));
						--	self:Changesilotype(self.inputFillType,self.inputFillTypeold);
						--else
							g_client:getServerConnection():sendEvent(ChangesilotypeEvent:new(self,self.inputFillType,self.outputFillType));
						--	self:Changesilotype(self.inputFillType,self.inputFillTypeold);
						--end;
				
					end;
				end;
		end;
	end;
end;


function moresilotype:Changesilotype(inputFillType,outputFillType)
    if self.isServer then
	self.inputFillType = inputFillType;
    self.outputFillType = outputFillType;
	
		local area = self.bunkerSiloArea;
		TipUtil.changeFillTypeAtArea(area.sx,area.sz, area.wx,area.wz, area.hx,area.hz, inputFillTypeold, inputFillType)

	
	self.acceptedFillTypes = {};
	if inputFillType == FillUtil.FILLTYPE_CCMRAW then
		dataString = "ccmraw";
		dataStringout = "ccm";
	else
		dataString = "chaff grass_windrow dryGrass_windrow";
		dataStringout = "silage";
	end;
    local data = Utils.splitString(" ", dataString);
    for i=1,table.getn(data) do
        local fillType = FillUtil.fillTypeNameToInt[data[i] ];
        if fillType ~= nil then
            self.acceptedFillTypes[fillType] = true;
        else
            print("Warning: BunkerSilo has an invalid fillType (acceptedFillTypes): "..tostring(data[i]));
        end;
	end;
	
    	
	
	TipUtil.removeConvertingFillTypeAreas(self.bunkerSiloArea);
	TipUtil.setConvertingFillTypeAreas(self.bunkerSiloArea, self.acceptedFillTypes, inputFillType);

		if self.isServer then
            self:raiseDirtyFlags(self.bunkerSiloDirtyFlag);
        end;
	end;
end;



moresilotypesaves=BunkerSilo.getSaveAttributesAndNodes
function BunkerSilo:getSaveAttributesAndNodes(nodeIdent)
local ipfill= FillUtil.fillTypeIntToName[self.inputFillType]
local ipfillold= FillUtil.fillTypeIntToName[self.inputFillTypeold]
	local attributes, nodes   = moresilotypesaves(self,nodeIdent)
    attributes = attributes .. ' inputfilltype="' .. tostring(ipfill).. '"';
    return attributes, nodes;
end;

	local moresilolfaan = BunkerSilo.loadFromAttributesAndNodes
function BunkerSilo:loadFromAttributesAndNodes(xmlFile, key)	

	local ipFill = getXMLString(xmlFile, key.."#inputfilltype");
	local oldcheck = getXMLString(xmlFile, key.."#inputfilltypeold");
	
	if ipFill=="nil" then
		ipFill="chaff"
	end;

	
	if oldcheck== nil then
	else
		if ipFill=="25" then
			ipFill="chaff"
		else
			ipFill="ccmraw"
		end;
	end;
	

	self.inputFillType =  FillUtil.fillTypeNameToInt[ipFill];
	if self.inputFillType==FillUtil.FILLTYPE_CCMRAW then
		self.outputFillType=FillUtil.FILLTYPE_CCM
	elseif self.inputFillType==FillUtil.FILLTYPE_GRASSILAGERAW then
		self.outputFillType=FillUtil.FILLTYPE_GRASSILAGE 
	else	
		self.outputFillType=FillUtil.FILLTYPE_SILAGE
	end;

	self:Changesilotype(self.inputFillType,self.outputFillType);

	
		local res = moresilolfaan(self,xmlFile, key)
    return true;
end;



moresilotyperstr = BunkerSilo.readStream
function BunkerSilo:readStream(streamId, connection)
    -- BunkerSilo:superClass().readStream(self, streamId, connection);
	moresilotyperstr(self,streamId, connection)
     if connection:getIsServer() then
        -- local state = streamReadUIntN(streamId, 3);
        -- self:setState(state);
        -- self.isOpenedAtFront = streamReadBool(streamId);
        -- self.isOpenedAtBack = streamReadBool(streamId);
        -- self.fillLevel = streamReadFloat32(streamId);
        self.inputFillType = streamReadUIntN(streamId,FillUtil.sendNumBits);
		self.outputFillType = streamReadUIntN(streamId,FillUtil.sendNumBits);
		--print("read Stream:  "..tostring(self.outputFillType))
        -- self.compactedPercent = math.floor( (streamReadUIntN(streamId, 8) / 2.55) + 0.5);
        -- self.fermentingPercent = math.floor( (streamReadUIntN(streamId, 8) / 2.55) + 0.5);
    end;
end;

moresilotypewstr = BunkerSilo.writeStream
function BunkerSilo:writeStream(streamId, connection)
    -- BunkerSilo:superClass().writeStream(self, streamId, connection);
	moresilotypewstr(self,streamId, connection)
    if not connection:getIsServer() then
        -- streamWriteUIntN(streamId, self.state, 3);
        -- streamWriteBool(streamId, self.isOpenedAtFront);
        -- streamWriteBool(streamId, self.isOpenedAtBack);
        -- streamWriteFloat32(streamId, self.fillLevel);

        streamWriteUIntN(streamId, self.inputFillType, FillUtil.sendNumBits);
		streamWriteUIntN(streamId, self.outputFillType, FillUtil.sendNumBits);
        -- streamWriteUIntN(streamId, 2.55*self.compactedPercent, 8);
        -- streamWriteUIntN(streamId, 2.55*self.fermentingPercent, 8);
    end;
end;

-- function moresilotype:readUpdateStream(streamId, timestamp, connection)
    -- BunkerSilo:superClass().readUpdateStream(self, streamId, timestamp, connection)
    -- if connection:getIsServer() then
        -- if streamReadBool(streamId) then
            -- local state = streamReadUIntN(streamId, 3);
            -- if state ~= self.state then
                -- self:setState(state, true);
            -- end
            -- self.fillLevel = streamReadFloat32(streamId);
			
            -- self.inputFillType = streamReadUIntN(streamId,FillUtil.FILLTYPE_CHAFF);
            -- self.inputFillTypeold = streamReadUIntN(streamId,FillUtil.FILLTYPE_CHAFF);
			-- self.outputFillType = streamReadUIntN(streamId,FillUtil.FILLTYPE_SILAGE);

            -- self.isOpenedAtFront = streamReadBool(streamId);
            -- self.isOpenedAtBack = streamReadBool(streamId);
            -- if self.state == BunkerSilo.STATE_FILL then
                -- self.compactedPercent =  math.floor( (streamReadUIntN(streamId, 8) / 2.55) + 0.5);
            -- elseif self.state == BunkerSilo.STATE_CLOSED or self.state == BunkerSilo.STATE_FERMENTED then
                -- self.fermentingPercent =  math.floor( (streamReadUIntN(streamId, 8) / 2.55) + 0.5);
            -- end
        -- end
    -- end;
-- end;

-- function moresilotype:writeUpdateStream(streamId, connection, dirtyMask)
    -- BunkerSilo:superClass().writeUpdateStream(self, streamId, connection, dirtyMask)
    -- if not connection:getIsServer() then
        -- if streamWriteBool(streamId, bitAND(dirtyMask, self.bunkerSiloDirtyFlag) ~= 0) then
            -- streamWriteUIntN(streamId, self.state, 3);
            -- streamWriteFloat32(streamId, self.fillLevel);

            -- streamWriteUIntN(streamId, self.inputFillType, FillUtil.FILLTYPE_CHAFF);
            -- streamWriteUIntN(streamId, self.inputFillTypeold, FillUtil.FILLTYPE_CHAFF);
			-- streamWriteUIntN(streamId, self.outputFillType, FillUtil.FILLTYPE_SILAGE);
            -- streamWriteBool(streamId, self.isOpenedAtFront);
            -- streamWriteBool(streamId, self.isOpenedAtBack);
            -- if self.state == BunkerSilo.STATE_FILL then
                -- streamWriteUIntN(streamId, 2.55*self.compactedPercent, 8);
            -- elseif self.state == BunkerSilo.STATE_CLOSED or self.state == BunkerSilo.STATE_FERMENTED then
                -- streamWriteUIntN(streamId, 2.55*self.fermentingPercent, 8);
            -- end
        -- end
    -- end;
-- end;


ChangesilotypeEvent = {};
ChangesilotypeEvent_mt = Class(ChangesilotypeEvent, Event);

InitEventClass(ChangesilotypeEvent, "ChangesilotypeEvent");

function ChangesilotypeEvent:emptyNew()
    local self = Event:new(ChangesilotypeEvent_mt);
    return self;
end;

function ChangesilotypeEvent:new(object,inputFillType,outputFillType)
    local self = ChangesilotypeEvent:emptyNew()  
	self.object = object;
	self.inputFillType = inputFillType
	self.outputFillType = outputFillType
    return self;
end;

function ChangesilotypeEvent:readStream(streamId, connection)

		self.object = readNetworkNodeObject(streamId);
        self.inputFillType = streamReadInt32(streamId);
        self.outputFillType = streamReadInt32(streamId);

    self:run(connection);
end;

function ChangesilotypeEvent:writeStream(streamId, connection)
		writeNetworkNodeObject(streamId, self.object);
        streamWriteInt32(streamId, self.inputFillType);
        streamWriteInt32(streamId, self.outputFillType);
end;

function ChangesilotypeEvent:run(connection)
    
	if self.object ~= nil then
        self.object:Changesilotype(self.inputFillType,self.outputFillType);
    end;
    if not connection:getIsServer() then
        g_server:broadcastEvent(ChangesilotypeEvent:new(self.object, self.inputFillType, self.outputFillType), nil, connection, self.object);
	end;



end;


--BunkerSilo.readStream = moresilotype.readStream;
--BunkerSilo.writeStream = moresilotype.writeStream;
--BunkerSilo.readUpdateStream = moresilotype.readUpdateStream;
--BunkerSilo.writeUpdateStream = moresilotype.writeUpdateStream;
--BunkerSilo.updateTick = moresilotype.updateTick;
--BunkerSilo.update = moresilotype.newupdate;
--BunkerSilo.loadFromAttributesAndNodes = moresilotype.loadFromAttributesAndNodes; 
BunkerSilo.Changesilotype = moresilotype.Changesilotype;